package betterwithmods.client.model;

import betterwithmods.common.blocks.tile.gen.TileEntityWaterwheel;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ResourceLocation;

public class TESRWaterwheel extends TileEntitySpecialRenderer<TileEntityWaterwheel> {
    private final ModelWaterwheel waterwheel;

    public TESRWaterwheel() {
        this.waterwheel = new ModelWaterwheel();
    }

    @Override
    public void func_192841_a(TileEntityWaterwheel te, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x + 0.5D, y + 0.5D, z + 0.5D);
        this.func_147499_a(new ResourceLocation("minecraft", "textures/blocks/planks_oak.png"));
        EnumFacing dir = te.getOrientation();
        float rotation = (te.getCurrentRotation() + (te.getMaximumInput(dir) == 0 ? 0 : partialTicks * te.getPrevRotation()));

        if (dir == EnumFacing.EAST) {
            waterwheel.setRotateAngle(waterwheel.axle, 0, 0, (float) Math.toRadians(rotation));
            GlStateManager.func_179114_b(90.0F, 0.0F, 1.0F, 0.0F);
        } else if (dir == EnumFacing.SOUTH) {
            waterwheel.setRotateAngle(waterwheel.axle, 0, 0, -(float) Math.toRadians(rotation));
        } else {
            waterwheel.setRotateAngle(waterwheel.axle, 0, (float) Math.toRadians(rotation), 0);
            GlStateManager.func_179114_b(90.0F, 1.0F, 0.0F, 0.0F);
        }

        this.waterwheel.render(0.0625F);
        GlStateManager.func_179121_F();
    }

}
